/**
binary-tools-1.0 is licensed for use as follows:

"""
Copyright (c) 2023 Rafael da Silva Rocha

This work is licensed under the Creative Commons
Attribution-NonCommercial-NoDerivatives 4.0 International
(CC-BY-NC-ND 4.0). To view a copy of this license, visit
https://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter
to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.

Under the terms of this license, you are free to:
- Share: copy and distribute the work in its original form.

If you distribute this work, you must:
- Attribute: give credit to the author/owner of the work.

You may not:
- Use this work for commercial purposes.
- Create derivative works based on the work.
- Remove or alter any copyright or attribution notices on the work.

This license is granted on a worldwide, non-exclusive, and royalty-free
basis and applies to any and all versions of the work.

By using or distributing this work, you agree to be bound by the terms of
this license. If you do not agree to the terms of this license, do not use
or distribute this work.
"""

This license notice applies to parts of binary-tools-1.0
defined in the source file /lib/float-parser.js:

"""
Copyright (c) 2017-2023 Rafael da Silva Rocha.
Copyright (c) 2013 DeNA Co., Ltd.
Copyright (c) 2010, Linden Research, Inc

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""
 */;var btools=(function(exports){var exports=exports||{};function l(a,c,d,b){b=void 0===b?a.length:b;for(d=void 0===d?0:d;d<b;d+=c){var e=a,f=c,g=d;f--;for(var h=0;h<f;h++){var k=e[g+h];e[g+h]=e[g+f];e[g+f]=k;f--}}}function m(){}m.prototype.pack=function(a,c,d){a[d]=c?1:0;return d+1};m.prototype.unpack=function(a,c){return!!a[c]};function p(a,c){this.bits=a.bits;this.offset=a.offset;this.max=Math.pow(2,this.bits)-1;this.min=0;a.signed&&(this.max=Math.floor(this.max/2),this.min=-this.max-1,this.unpack=this.o);if(void 0===c?0:c)this.i=this.m}
p.prototype.pack=function(a,c,d){if(!isFinite(c)||Math.floor(c)!==c)throw new TypeError;c=this.i(c);c=0>c?c+2*this.max+2:c;for(var b=0,e=this.offset;b<e;b++)a[d]=Math.floor(c/Math.pow(2,8*b))&255,d++;return d};p.prototype.unpack=function(a,c){return this.i(q(this,a,c))};p.prototype.o=function(a,c){var d=q(this,a,c);d>this.max&&(d-=2*this.max+2);return d};function q(a,c,d){for(var b=0,e=0;e<a.offset;e++)b+=c[d+e]*Math.pow(256,e);return b}
p.prototype.i=function(a){if(a>this.max||a<this.min)throw new RangeError;return a};p.prototype.m=function(a){return a>this.max?this.max:a<this.min?this.min:a};function r(a){this.bits=a.bits;this.offset=a.offset;this.i=8;this.m=23;16!=this.bits||a.b?64==this.bits&&(this.i=11,this.m=52):(this.i=5,this.m=11);this.o=(1<<this.i-1)-1;this.C=Math.pow(2,this.o+1);this.D=Math.pow(2,-(8*this.offset-1-this.i))}
r.prototype.pack=function(a,c,d){if("number"!==typeof c)throw new TypeError;Math.abs(c)>this.C-2*this.bits&&(c=0>c?-Infinity:Infinity);var b=0>((c=+c)||1/c)?1:0;c=Math.abs(c);var e=Math.min(Math.floor(Math.log(c)/Math.LN2),1023),f=Math.round(c/Math.pow(2,e)*Math.pow(2,this.m));if(c!==c){if(23==this.m&&2==this.offset)return a[d]=193,a[d+1]=255,d+2;f=Math.pow(2,this.m-1);e=(1<<this.i)-1}else 0!==c&&(c>=Math.pow(2,1-this.o)?(2<=f/Math.pow(2,this.m)&&(e+=1,f=1),e>this.o?(e=(1<<this.i)-1,f=0):(e+=this.o,
f=Math.round(f)-Math.pow(2,this.m))):(f=Math.round(c/Math.pow(2,1-this.o-this.m)),e=0));c=[];c.push(b);for(b=this.i;0<b;--b)c[b]=e%2?1:0,e=Math.floor(e/2);b=c.length;for(e=this.m;0<e;--e)c[b+e]=f%2?1:0,f=Math.floor(f/2);b=c.join("");f=this.offset+d-1;for(c=d;f>=d;)a[f]=parseInt(b.substring(0,8),2),b=b.substring(8),f--,c++;return c};
r.prototype.unpack=function(a,c){for(var d=(1<<this.i)-1,b="",e=this.offset-1;0<=e;e--){var f=a[e+c].toString(2);b+="00000000".substring(f.length)+f}e="1"==b.charAt(0)?-1:1;b=b.substring(1);f=parseInt(b.substring(0,this.i),2);b=b.substring(this.i);if(f==d)return 0!==parseInt(b,2)?NaN:Infinity*e;0===f?(f+=1,d=parseInt(b,2)):d=parseInt("1"+b,2);return e*d*this.D*Math.pow(2,f-this.o)};
var t={x:{bits:0,signed:!1,fp:!1,b:!1},c:{bits:8,signed:!0,fp:!1,b:!0},b:{bits:8,signed:!0,fp:!1,b:!1},B:{bits:8,signed:!1,fp:!1,b:!1},"?":{bits:1,signed:!1,fp:!1,b:!1},h:{bits:16,signed:!0,fp:!1,b:!1},H:{bits:16,signed:!1,fp:!1,b:!1},e:{bits:16,signed:!0,fp:!0,b:!1},g:{bits:16,signed:!0,fp:!0,b:!0},t:{bits:24,signed:!0,fp:!1,b:!1},T:{bits:24,signed:!1,fp:!1,b:!1},l:{bits:32,signed:!0,fp:!1,b:!1},L:{bits:32,signed:!1,fp:!1,b:!1},f:{bits:32,signed:!0,fp:!0,b:!1},j:{bits:40,signed:!0,fp:!1,b:!1},J:{bits:40,
signed:!1,fp:!1,b:!1},k:{bits:48,signed:!0,fp:!1,b:!1},K:{bits:48,signed:!1,fp:!1,b:!1},d:{bits:64,signed:!0,fp:!0,b:!1}};function u(a){v(a);a=a.replace(/!/g,">");a=(">"==a.charAt(0)?">":"<")+a.replace(/[<>!]/g,"");for(var c="",d={F:a,u:0,size:0,endianness:a.charAt(0),types:[]},b=1,e=a.length;b<e;b++){var f=a.charAt(b);isNaN(f)?w("1",a,d,b):(c+=f,isNaN(parseInt(a.charAt(b+1),10))&&b+1<e&&(w(c,a,d,b+1),c="",b++))}return d}
function w(a,c,d,b){a=0<parseInt(a,10)?parseInt(a,10):1;b=t[c.charAt(b)];b.v=">"==c.charAt(0);b.offset=Math.ceil((b.bits?b.bits:1)/8);d.types.push({s:b,A:a});d.u+=0<b.bits?a:0;d.size+=0<b.bits?b.offset*a:a}function v(a){if("string"!=typeof a)throw Error("Unsupported type");a=a.replace(/[<>!]/g,"");if(0==a.length)throw Error("Unsupported type");for(var c=0;c<a.length;c++){var d=a.charAt(c);if(!(d in t)&&isNaN(d))throw Error("Unsupported type");}}
function x(a,c,d,b,e){b=void 0===b?0:b;e=void 0===e?!1:e;a=u(a);c=y(c);void 0!==d.byteLength&&c.length&&z(a.size,d,b);return A(a.types[0].s,c,d,b,e)}function B(a,c,d,b,e,f){b=void 0===b?0:b;e=void 0===e?c.length:e;f=void 0===f?!1:f;a=u(a).types[0].s;var g=Math.ceil(a.bits/8),h=(e-b)%g;if(f&&(h||c.length<g))throw Error("Bad buffer length");C(a,c,d,b,e-h,0)}
function A(a,c,d,b,e){e=D(a,e);var f=0,g=b;try{for(var h=c.length;f<h;f++)b=e.pack(d,c[f],b)}catch(k){throw k.message=k.constructor.name+" at index "+f+": "+c[f],k;}a.v&&l(d,a.offset,g,b);return b}function C(a,c,d,b,e,f){if(!(c.length<e)){c=c.slice();var g=D(a);a.v&&l(c,a.offset,b,e);try{for(var h=a.offset;b<e;b+=h,f++)d[f]=g.unpack(c,b)}catch(k){throw k.message=k.constructor.name+" at index "+b+": "+c[b],k;}}}
function E(a,c,d,b){for(var e=a.types.length,f=0,g=0;f<e;f++){var h=a.types[f].A,k=a.types[f].s,n=a.types[f].s.offset*h;0==k.bits?b+=1:(C(k,c,d,b,b+n,g),b+=n,g+=h)}}function F(a,c,d,b,e){for(var f=a.types.length,g=0,h=0;g<f;g++)for(var k=a.types[g].A,n=0;n<k;n++)0==a.types[g].s.bits?(d[b]=0,b++):(b=A(a.types[g].s,[c[h]],d,b,e),h++);return b}
function D(a,c){if(0==a.bits||1==a.bits||8==a.bits&&a.b)return new m;if(a.fp){var d=a.bits;if(!d||16!==d&&32!==d&&64!==d)throw Error("Unsupported type");return new r(a)}d=a.bits;if(null==d||void 0==d||0==d||2>d||53<d)throw Error("Unsupported type");return new p(a,void 0===c?!1:c)}function z(a,c,d){if(c.length-d<a)throw Error("Bad buffer length");}function y(a){null!==a&&void 0!==a&&"function"!==typeof a&&"number"===typeof a.length&&0<=a.length&&a.length===Math.floor(a.length)||(a=[a]);return a}
exports.calcSize=function(a){v(a);return u(a).size};exports.endianness=l;exports.pack=function(a,c,d){d=void 0===d?!1:d;c=y(c);a=u(a);if(a.u>c.length)throw Error("Number of values do not match the format");var b=[];F(a,c,b,0,d);return b};exports.packTo=function(a,c,d,b,e){b=void 0===b?0:b;e=void 0===e?!1:e;c=y(c);a=u(a);if(a.u>c.length)throw Error("Number of values do not match the format");z(a.size,d,b);return b=F(a,c,d,b,e)};
exports.read=function(a,c,d,b,e){b=void 0===b?c.length:b;var f=[];B(a,c,f,void 0===d?0:d,b,void 0===e?!1:e);return f};exports.readTo=B;exports.types=t;exports.unpack=function(a,c,d,b){d=void 0===d?0:d;b=void 0===b?!1:b;a=u(a);b&&z(a.size,c,d);b=[];E(a,c,b,d);return b};exports.unpackTo=function(a,c,d,b,e){b=void 0===b?0:b;e=void 0===e?!1:e;a=u(a);e&&z(a.size,c,b);E(a,c,d,b)};exports.write=function(a,c,d){var b=[];x(a,c,b,0,void 0===d?!1:d);return b};exports.writeTo=x;typeof module!=='undefined'?module.exports=exports :typeof define==='function'&&define.amd?define(['exports'],exports) :typeof global!=='undefined'?global.btools=exports:null;return exports;})()
